POJ 2528 Mayor's posters 线段树

Mayor's posters
Time Limit: 1000MS
Memory Limit: 65536K
Total Submissions: 39344
Accepted: 11424

Description

The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral posters at all places at their whim. The city council has finally decided to build an electoral wall for placing the posters and introduce the following rules:
  • Every candidate can place exactly one poster on the wall.
  • All posters are of the same height equal to the height of the wall; the width of a poster can be any integer number of bytes (byte is the unit of length in Bytetown).
  • The wall is divided into segments and the width of each segment is one byte.
  • Each poster must completely cover a contiguous number of wall segments.

They have built a wall 10000000 bytes long (such that there is enough place for all candidates). When the electoral campaign was restarted, the candidates were placing their posters on the wall and their posters differed widely in width. Moreover, the candidates started placing their posters on wall segments already occupied by other posters. Everyone in Bytetown was curious whose posters will be visible (entirely or in part) on the last day before elections.
Your task is to find the number of visible posters when all the posters are placed given the information about posters' size, their place and order of placement on the electoral wall.

Input

The first line of input contains a number c giving the number of cases that follow. The first line of data for a single case contains number 1 <= n <= 10000. The subsequent n lines describe the posters in the order in which they were placed. The i-th line among the n lines contains two integer numbers li and ri which are the number of the wall segment occupied by the left end and the right end of the i-th poster, respectively. We know that for each 1 <= i <= n, 1 <= li <= ri <= 10000000. After the i-th poster is placed, it entirely covers all wall segments numbered li, li+1 ,... , ri.

Output

For each input data set print the number of visible posters after all the posters are placed.

The picture below illustrates the case of the sample input.

Sample Input

1
5
1 4
2 6
8 10
3 4
7 10

Sample Output

4

Source

Alberta Collegiate Programming Contest 2003.10.18

传送门:POJ 2528 Mayor's posters

题目大意:给你n幅海报,海报按给出顺序依次覆盖到坐标轴上,问最后能看到多少幅海报。
题目分析:
首先海报最长可以到达1000000,所以需要离散化。
而且,需要注意的是,海报覆盖的是区间线段,而不是区间点,所以在离散化的时候,不能简单离散化。
解决方法是:在离散化后的坐标中,如果相邻两个点的原坐标不相邻,则说明中间那一段是空出来的(一定有至少两块板的间距是这样),所以我们在中间可以随便添加数字且不能和所有的已经出现的重复,在这里我将添加的数赋值为左端的数加一(在后面你可以知道这样做的意义)。将坐标离散化且添加中间元素后,我们怎样找到原坐标对应的下标?
方法一:遍历数组。O(n)。很明显,速度不够快。
方法二:二分查找。O(logn)。的确很快,但是二分查找需要单调性,所以添加的元素必须是两坐标之间的任意数,确保单调性(现在应该明白了我上面的做法了把:))。

找到相对坐标后,直接插入到线段树中就好啦~~

代码如下:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std ;

#define lson l , m , o << 1
#define rson m + 1 , r , o << 1 | 1
#define clear( A , X ) memset ( A , X , sizeof A )
const int maxN = 10005 ;

int col[maxN << 4] ;
bool cover[maxN] ;
int a[maxN << 2] , b[maxN << 2];
int LL[maxN] , RR[maxN] ;

int Unique ( int *a , int n ) {//离散,返回最后数据的个数
	int cnt = 0 ;
	sort ( a , a + n ) ;
	b[0] = a[0] ;
	for ( int i = 1 ; i < n ; ++ i ) {//unique
		if ( a[i] != b[cnt] ) b[++ cnt] = a[i] ;
	}
	n = cnt + 1 ;
	cnt = 0 ;
	for ( int i = 1 ; i < n ; ++ i) {//添加中间元素
		if ( b[i] != a[cnt] + 1 ) {
			a[cnt + 1] = a[cnt] + 1 ;//确保单调性,以便二分查找
			++ cnt ;
		}
		a[++ cnt] = b[i] ;
	}
	return cnt + 1 ;
}

int Binary_Search ( int *a , int key , int n ) {
	int l = 0 , r = n ;
	while ( l < r ) {
		int m = ( l + r ) / 2 ;
		if ( key <= a[m] ) r = m ;
		else l = m + 1 ;
	}
	return l ;
}

void PushDown ( int o ) {
	if ( col[o] ) {
		col[o << 1] = col[o << 1 | 1] = col[o] ;
		col[o] = 0 ;
	}
}

void Update ( int L , int R , int v , int l , int r , int o ) {
	if ( L <= l && r <= R ) {
		col[o] = v ;
		return ;
	}
	PushDown ( o ) ;
	int m = ( l + r ) >> 1 ;
	if ( L <= m ) Update ( L , R , v , lson ) ;
	if ( m <  R ) Update ( L , R , v , rson ) ;
}

void Query ( int l , int r , int o ) {
	if ( col[o] || l == r ) {
		cover[col[o]] = 1 ;
		//printf ( "l = %d , r = %d , col[%d] = %d\n" , l , r , o , col[o] ) ;
		return ;
	}
	//PushDown ( o ) ;很明显不需要了,因为只要不同的颜色,而PushDown下去的必定是同种颜色
	int m = ( l + r ) >> 1 ;
	Query ( lson ) ;
	Query ( rson ) ;
}	

void work () {
	int n , l , r , c , cnt , color ;
	scanf ( "%d" , &n ) ;
	clear ( col , 0 ) ;
	clear ( cover , 0 ) ;
	cnt = 0 ;
	for ( int i = 1 ; i <= n ; ++ i ) {
		scanf ( "%d%d" , &LL[i] , &RR[i] ) ;
		a[cnt ++] = LL[i] ;
		a[cnt ++] = RR[i] ;
	}
	cnt = Unique ( a , cnt ) ;
	for ( int i = 1 ; i <= n ; ++ i ) {
		l = Binary_Search ( a , LL[i] , cnt ) ;
		r = Binary_Search ( a , RR[i] , cnt ) ;
		//printf ( "l = %d r = %d\n" , l , r ) ;
		Update ( l + 1 , r + 1 , i , 1 , cnt , 1 ) ;
	}
	Query ( 1 , cnt , 1 ) ;
	color = 0 ;
	for ( int i = 1 ; i <= n ; ++ i ) {
		color += cover[i] ;
	}
	printf ( "%d\n" , color ) ;
}
int main () {
	int T ;
	scanf ( "%d" , &T ) ;
	while ( T -- ) {
		work () ;
	}
	return 0 ;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值